=== modified file 'bzrlib/tests/tree_implementations/test_tree.py'
--- bzrlib/tests/tree_implementations/test_tree.py	2008-06-20 19:06:38 +0000
+++ bzrlib/tests/tree_implementations/test_tree.py	2008-07-02 19:02:34 +0000
@@ -191,3 +191,15 @@
         work_tree = self.make_branch_and_tree('wt')
         tree = self._convert_tree(work_tree)
         self.assertIsInstance(tree.conflicts(), conflicts.ConflictList)
+
+
+class TestIterEntriesByDir(TestCaseWithTree):
+
+    def test_iteration_order(self):
+        work_tree = self.make_branch_and_tree('.')
+        self.build_tree(['a/', 'a/b/', 'a/b/c', 'a/d/', 'a/d/e', 'f/', 'f/g'])
+        work_tree.add(['a', 'a/b', 'a/b/c', 'a/d', 'a/d/e', 'f', 'f/g'])
+        tree = self._convert_tree(work_tree)
+        output_order = [p for p, e in tree.iter_entries_by_dir()]
+        self.assertEqual(['', 'a', 'f', 'a/b', 'a/d', 'a/b/c', 'a/d/e', 'f/g'],
+                         output_order)

=== modified file 'bzrlib/transform.py'
--- bzrlib/transform.py	2008-06-26 17:30:10 +0000
+++ bzrlib/transform.py	2008-07-02 19:08:43 +0000
@@ -1532,7 +1532,7 @@
             children = list(self._all_children(parent))
             paths = dict(zip(children, self._final_paths.get_paths(children)))
             children.sort(key=paths.get)
-            todo.extend(children)
+            todo.extend(reversed(children))
             for trans_id in children:
                 ordered_ids.append((trans_id, parent_file_id))
         for entry, trans_id in self._make_inv_entries(ordered_ids,

=== modified file 'bzrlib/tree.py'
--- bzrlib/tree.py	2008-07-02 13:24:08 +0000
+++ bzrlib/tree.py	2008-07-02 19:02:34 +0000
@@ -194,7 +194,7 @@
            f/
              g
 
-        The yield order would be::
+        The yield order (ignoring root) would be::
           a, f, a/b, a/d, a/b/c, a/d/e, f/g
         """
         return self.inventory.iter_entries_by_dir(

